## pytango 9.5.0

=== CMakeLists.txt ===
# cmake_minimum_required(VERSION 3.16)  # Ubuntu 20.04 ships with cmake 3.16.3
# cmake_minimum_required(VERSION 3.17)  # cmake 3.17 added support for conda environments FindPython
cmake_minimum_required(VERSION 3.18)  # cmake 3.18 supported in debian bullseye and cppTango
# cmake_minimum_required(VERSION 3.25)  # latest release. Available as pip install cmake

include(cmake/prelude.cmake)

project(
    pytango
    VERSION 9.5.0
    DESCRIPTION "Python bindings for the Tango distributed control system"
    HOMEPAGE_URL "https://pytango.readthedocs.io/"
    LANGUAGES CXX
)

include(cmake/project-is-top-level.cmake)

set(CMAKE_CXX_STANDARD 14)

# ---- Dependencies -------

# A temporary method for finding Tango and its dependencies is
# to use the cmake/Find*.cmake files. Longer term solution would be for
# cppTango to export/install a tango-config.cmake file and use find_package
# in CONFIG mode: find_package(tango REQUIRED CONFIG)
# See: https://gitlab.com/tango-controls/TangoTickets/-/issues/81
# The FindTango.cmake will attempt to find tango first using pkg-config
# but gracefully try using cmake ways if pkg-config is not available (i.e. Windows)
# or tango is not found.
# Use the environment/cache variable Tango_ROOT to set the tango installation prefix.
list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
find_package(Tango REQUIRED)

# Find Python and NumPy
# https://cmake.org/cmake/help/latest/module/FindPython.html
if (DEFINED ENV{PYTHON_ROOT})
    set(Python_ROOT_DIR "$ENV{PYTHON_ROOT}" CACHE STRING "Python root installation path")
    set(Python_FIND_STRATEGY LOCATION)
endif()
find_package (Python 3.8 COMPONENTS Interpreter Development NumPy)
message(STATUS "    Python version:  ${Python_VERSION}")
message(STATUS "      - intepreter:  ${Python_EXECUTABLE}")
message(STATUS "       - libraries:  ${Python_LIBRARIES}")
message(STATUS "       - libraries:  ${Python_LIBRARY_DIRS}")
message(STATUS "     NumPy version:  ${Python_NumPy_VERSION}")
message(STATUS "     - include dir:  ${Python_NumPy_INCLUDE_DIRS}")

# Find boost.python library.
# Work around the boost python suffix issue for Boost versions < 1.73.
# (See https://github.com/boostorg/boost_install/issues/31)
# By default we search for the component "python3" which works for Boost >= 1.73
# However, for example Ubuntu 20.04 ships with Boost 1.71 and here the developer/CI
# can set and override the cache variable BOOST_PYTHON_SUFFIX to "38" (default "3")
if (DEFINED ENV{BOOST_PYTHON_SUFFIX})
    set(BOOST_PYTHON_SUFFIX "$ENV{BOOST_PYTHON_SUFFIX}" CACHE STRING "Sets the suffix on the Boost Python component to search for (default is 3). Set this only if your Boost version is < 1.73")
else()
    set(BOOST_PYTHON_SUFFIX "3" CACHE STRING "Sets the suffix on the Boost Python component to search for (default is 3). Set this only if your Boost version is < 1.73")
endif()
set(Boost_VERBOSE "ON")
find_package(Boost 1.71 REQUIRED COMPONENTS python${BOOST_PYTHON_SUFFIX} CONFIG)
message(STATUS "Boost Python version: ${Boost_PYTHON_VERSION}")

# Just a sanity check: the python used to build pytango should match the
# version used to build libboost_python. This could be changed from WARNING to ERROR(?)
# cmake hack: using VERSION_EQUAL would be better but Python reports a full MAJOR.MINOR.PATCH
#             version number whereas boost-python only reports MAJOR.MINOR. MATCHES works but
#             we're pretending that the shorter version string is a regex.
if(NOT ${Python_VERSION} MATCHES ${Boost_PYTHON_VERSION})
    message(FATAL_ERROR "The interpreter/library python version (${Python_VERSION}) does not match the version of python that libboost_python was built with (${Boost_PYTHON_VERSION})")
endif()

# ---- Declare library ----
# A python extension module library must be shared
add_library(
    pytango_tango SHARED
    ext/device_attribute.cpp
    ext/device_proxy.cpp
    ext/pytgutils.cpp
    ext/base_types.cpp
    ext/attribute_alarm_info.cpp
    ext/attribute_info_ex.cpp
    ext/device_data.cpp
    ext/callback.cpp
    ext/command_info.cpp
    ext/device_attribute_config.cpp
    ext/exception.cpp
    ext/devintr_change_event_data.cpp
    ext/db.cpp
    ext/version.cpp
    ext/dev_error.cpp
    ext/pipe_event_data.cpp
    ext/device_pipe.cpp
    ext/to_py.cpp
    ext/pipe_info.cpp
    ext/constants.cpp
    ext/api_util.cpp
    ext/dev_command_info.cpp
    ext/change_event_info.cpp
    ext/server/tango_util.cpp
    ext/server/pipe.cpp
    ext/server/device_impl.cpp
    ext/server/attr.cpp
    ext/server/command.cpp
    ext/server/multi_class_attribute.cpp
    ext/server/log4tango.cpp
    ext/server/encoded_attribute.cpp
    ext/server/auto_monitor.cpp
    ext/server/attribute.cpp
    ext/server/device_class.cpp
    ext/server/multi_attribute.cpp
    ext/server/subdev.cpp
    ext/server/user_default_pipe_prop.cpp
    ext/server/fwdAttr.cpp
    ext/server/dserver.cpp
    ext/server/wattribute.cpp
    ext/server/user_default_attr_prop.cpp
    ext/attr_conf_event_data.cpp
    ext/device_info.cpp
    ext/periodic_event_info.cpp
    ext/database.cpp
    ext/precompiled_header.cpp
    ext/enums.cpp
    ext/attribute_proxy.cpp
    ext/pyutils.cpp
    ext/attribute_event_info.cpp
    ext/attribute_dimension.cpp
    ext/archive_event_info.cpp
    ext/locking_thread.cpp
    ext/device_data_history.cpp
    ext/from_py.cpp
    ext/group_reply.cpp
    ext/device_attribute_history.cpp
    ext/locker_info.cpp
    ext/group_reply_list.cpp
    ext/time_val.cpp
    ext/connection.cpp
    ext/attribute_info.cpp
    ext/pytango.cpp
    ext/poll_device.cpp
    ext/group.cpp
    ext/event_data.cpp
    ext/data_ready_event_data.cpp
)
add_library(pytango::tango ALIAS pytango_tango)

set_target_properties(
    pytango_tango PROPERTIES
    CXX_VISIBILITY_PRESET hidden
    VISIBILITY_INLINES_HIDDEN YES
    VERSION "${PROJECT_VERSION}"
    SOVERSION "${PROJECT_VERSION_MAJOR}"
    EXPORT_NAME tango
    OUTPUT_NAME tango
    PREFIX "_"
    COMPILE_OPTIONS "-DPYTANGO_NUMPY_VERSION=${Python_NumPy_VERSION};-DNPY_NO_DEPRECATED_API=0"
)
if ( CMAKE_SYSTEM_NAME MATCHES "Darwin" )
  # .so suffix is default on linux and required for python to load
    # the extension module. On MacOS the default is .dylib so we have
    # to force the suffix here.
    set_target_properties(pytango_tango PROPERTIES SUFFIX ".so")  
endif()
if (WIN32)
    set_target_properties(
        pytango_tango PROPERTIES
        SUFFIX ".pyd"
        COMPILE_OPTIONS "/bigobj"
    )
endif()

target_include_directories(
    pytango_tango
    PUBLIC
    "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/ext>"
)

target_compile_features(pytango_tango PUBLIC cxx_std_14)

target_link_libraries(pytango_tango PRIVATE Python::Module Python::NumPy Boost::python Tango::Tango)

install(TARGETS pytango_tango
	LIBRARY DESTINATION tango
	RUNTIME DESTINATION tango)

# ---- Developer mode ----

if(NOT pytango_DEVELOPER_MODE)
  return()
elseif(NOT PROJECT_IS_TOP_LEVEL)
  message(
      AUTHOR_WARNING
      "Developer mode is intended for developers of pytango"
  )
endif()

=== doc/requirements.txt ===
#
# This file is autogenerated by pip-compile with Python 3.11
# by the following command:
#
#    pip-compile requirements.in
#
alabaster==0.7.13
    # via sphinx
babel==2.13.0
    # via sphinx
certifi==2023.7.22
    # via requests
charset-normalizer==3.3.0
    # via requests
docutils==0.18.1
    # via
    #   sphinx
    #   sphinx-rtd-theme
gevent==23.9.1
    # via -r requirements.in
graphviz==0.20.1
    # via -r requirements.in
greenlet==3.0.0
    # via gevent
idna==3.4
    # via requests
imagesize==1.4.1
    # via sphinx
jinja2==3.1.2
    # via sphinx
markupsafe==2.1.3
    # via jinja2
numpy==1.26.0
    # via -r requirements.in
packaging==23.2
    # via
    #   -r requirements.in
    #   sphinx
pillow==10.0.1
    # via -r requirements.in
psutil==5.9.5
    # via -r requirements.in
pygments==2.16.1
    # via sphinx
requests==2.31.0
    # via sphinx
snowballstemmer==2.2.0
    # via sphinx
sphinx==7.2.6
    # via
    #   -r requirements.in
    #   sphinx-rtd-theme
    #   sphinxcontrib-applehelp
    #   sphinxcontrib-devhelp
    #   sphinxcontrib-htmlhelp
    #   sphinxcontrib-jquery
    #   sphinxcontrib-qthelp
    #   sphinxcontrib-serializinghtml
sphinx-rtd-theme==1.3.0
    # via -r requirements.in
sphinxcontrib-applehelp==1.0.7
    # via sphinx
sphinxcontrib-devhelp==1.0.5
    # via sphinx
sphinxcontrib-htmlhelp==2.0.4
    # via sphinx
sphinxcontrib-jquery==4.1
    # via sphinx-rtd-theme
sphinxcontrib-jsmath==1.0.1
    # via sphinx
sphinxcontrib-qthelp==1.0.6
    # via sphinx
sphinxcontrib-serializinghtml==1.1.9
    # via sphinx
urllib3==2.0.6
    # via requests
zope-event==5.0
    # via gevent
zope-interface==6.1
    # via gevent

# The following packages are considered to be unsafe in a requirements file:
# setuptools

=== debian/changelog ===
pytango (9.5.0-6) unstable; urgency=medium

  * Rerun failed tests in testsuite (this may fix #1076830).
  * Also mark one flaky test as such.

 -- Roland Mas <lolando@debian.org>  Wed, 02 Oct 2024 17:50:58 +0200

pytango (9.5.0-5) unstable; urgency=medium

  * Increase timeout in testsuite (this may fix #1076830).

 -- Roland Mas <lolando@debian.org>  Thu, 25 Jul 2024 09:33:08 +0200

pytango (9.5.0-4) unstable; urgency=medium

  * Team upload.
  * Add myself to Uploaders.
  * Build-Deps on python3-all-dev again to build against all versions of Python.
  * Use more dh_* stuff to streamline debian/rules a bit.

 -- Roland Mas <lolando@debian.org>  Wed, 10 Jul 2024 15:21:30 +0200

pytango (9.5.0-3) unstable; urgency=medium

  * Team upload.
  * Drop old extraneous build dependencies:
    * python3-mock (Closes: #1069734)
    * python3-six (Closes: #1064615)

 -- Alexandre Detiste <tchet@debian.org>  Sat, 29 Jun 2024 16:18:36 +0200

pytango (9.5.0-2) unstable; urgency=medium

  * Team upload.
  * Upload to unstable
  * Temporarily remove s390x from python3-tango's Architecture:, until
    https://gitlab.com/tango-controls/pytango/-/issues/449 gets solved
  * Temporarily test against default python3 version only, until I can solve
    how to build for several versions

 -- Santiago Ruano Rincón <santiago@freexian.com>  Mon, 12 Feb 2024 10:08:49 -0300

pytango (9.5.0-2~exp2) experimental; urgency=medium

  * Team upload.
  * Temporarily remove s390x from python3-tango's Architecture:, until
    https://gitlab.com/tango-controls/pytango/-/issues/449 gets solved
  * Temporarily test against default python3 version only, until I can solve
    how to build for several versions

 -- Santiago Ruano Rincón <santiago@freexian.com>  Mon, 05 Feb 2024 09:15:53 -0300

pytango (9.5.0-2~exp1) experimental; urgency=medium

  * Team upload.
  * Make tests are run again during building. Explicitly tell pybuild to use
    pytest

 -- Santiago Ruano Rincón <santiago@freexian.com>  Fri, 26 Jan 2024 16:36:02 -0300

pytango (9.5.0-1) unstable; urgency=medium

  * Team upload.
  * Upload to unstable.

 -- Santiago Ruano Rincón <santiago@freexian.com>  Tue, 09 Jan 2024 07:32:49 -0500

pytango (9.5.0-1~exp2) experimental; urgency=medium

  * Team upload.
  * Build-Deps on python3-dev instead of python3-all-dev. Only building for
    the default python version, at least, temporarily
  * d/rules: don't install spare .so files (Closes: #1059792)

 -- Santiago Ruano Rincón <santiago@freexian.com>  Mon, 08 Jan 2024 17:52:56 -0500

pytango (9.5.0-1~exp1) experimental; urgency=medium

  * Team upload.
  * New upstream version 9.5.0
    * Fix FTBFS with Python 3.12 (Closes: #1049843, #1055733). Although, it
      builds for the default python version only.
  * Add d/gbp.conf
  * Set RELEASE to experimental in debian/salsa-ci.yml
  * Add and/or update Build-Depends: cmake, libboost-python-dev (>= 1.83.0),
    tango >= 9.5.0, pybuild-plugin-pyproject, python3-pathspec,
    python3-pyproject-metadata and python3-scikit-build-core
  * Update d/patches/0002-Added-gevent-to-instal_requires.patch and
    remove-junitxml-report.patch to use pyproject.toml
  * Update debian/patches/ftbfs-ipv6.patch

 -- Santiago Ruano Rincón <santiago@freexian.com>  Thu, 21 Dec 2023 18:24:21 -0300

=== debian/control ===
Source: pytango
Maintainer: Debian Science Maintainers <debian-science-maintainers@lists.alioth.debian.org>
Uploaders:
 Picca Frédéric-Emmanuel <picca@debian.org>,
 Sandor Bodo-Merle <sbodomerle@gmail.com>,
 Roland Mas <lolando@debian.org>,
Section: science
Priority: optional
Build-Depends:
 cmake,
 cppzmq-dev,
 debhelper-compat (= 13),
 dh-sequence-numpy3,
 dh-sequence-python3,
 libboost-python-dev (>= 1.83.0),
 libtango-dev (>= 9.5.0+dfsg1),
 pkg-config,
 pybuild-plugin-pyproject,
 python3-all-dev,
 python3-gevent,
 python3-numpy,
 python3-pathspec,
 python3-psutil <!nocheck>,
 python3-pyproject-metadata,
 python3-pytest <!nocheck>,
 python3-pytest-forked <!nocheck>,
 python3-pytest-rerunfailures <!nocheck>,
 python3-scikit-build-core,
 python3-setuptools,
 tango-test (>= 9.5.0+dfsg1) <!nocheck>,
Build-Depends-Indep:
 dh-sequence-sphinxdoc <!nodoc>,
 graphviz <!nodoc>,
 python3-sphinx <!nodoc>,
 python3-sphinx-rtd-theme <!nodoc>,
 sphinx-common <!nodoc>,
Standards-Version: 4.6.1
Vcs-Browser: https://salsa.debian.org/science-team/pytango
Vcs-Git: https://salsa.debian.org/science-team/pytango.git
Homepage: https://pytango.readthedocs.io/en/latest/
Rules-Requires-Root: no

Package: python3-tango
# Architecture: any [!390x]
Architecture: alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 ia64 loong64 m68k mips64el powerpc ppc64 ppc64el riscv64 sh4 sparc64 x32
Section: python
Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
Provides: ${python3:Provides},
Description: API for the TANGO control system (Python 3)
 TANGO is an object oriented distributed control system using CORBA,
 mainly developed by the Controls Section of the ALBA Synchrotron.
 PyTango provides bindings for its client- and server-side C++ APIs.
 With PyTango, you can write TANGO device servers and TANGO applications
 (scripts, CLIs, GUIs) that access TANGO device servers in pure Python.
 .
 This is the Python 3 version of the package.

Package: python-tango-doc
Architecture: all
Section: doc
Depends: ${misc:Depends}, ${sphinxdoc:Depends},
Breaks: python-pytango-doc (<< 9.2.0-2~),
Replaces: python-pytango-doc (<< 9.2.0-2~),
Description: API for the TANGO control system
 TANGO is an object oriented distributed control system using CORBA,
 mainly developed by the Controls Section of the ALBA Synchrotron.
 PyTango provides bindings for its client- and server-side C++ APIs.
 With PyTango, you can write TANGO device servers and TANGO applications
 (scripts, CLIs, GUIs) that access TANGO device servers in pure Python.
 .
 This package contains the documentation for the python-tango library.

=== debian/rules ===
#!/usr/bin/make -f

export PYBUILD_NAME=tango
export PYBUILD_TEST_ARGS=--reruns 5
%:
	dh $@ --buildsystem=pybuild

execute_after_dh_auto_build-indep:
	dh_auto_build --buildsystem=pybuild -- -s custom --build-args="PYTHONPATH={build_dir} {interpreter} -m sphinx -N -bhtml doc build/html"

override_dh_auto_test:
	PATH="/usr/lib/tango/:$$PATH" dh_auto_test --buildsystem=pybuild -- --test-pytest

=== debian/tests/control ===
Test-Command: set -efu
 ; cp  -r tests "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; PATH=/usr/lib/tango/:$PATH $py -m pytest tests -v --forked --reruns 5
 ; done
Depends:
 python3-dev,
 python3-psutil,
 python3-pytest,
 python3-pytest-forked,
 python3-pytest-rerunfailures,
 python3-tango,
 tango-test,
Restrictions: allow-stderr, skip-not-installable, isolation-container

Test-Command: set -efu
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -c "import tango; print(tango.Database().get_info())"
 ; done
Depends: default-mysql-server, python3-dev, python3-tango, tango-db,
Restrictions: allow-stderr, skip-not-installable, isolation-container, flaky

## pytango 10.0.0

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,15 +7,13 @@
 
 project(
     pytango
-    VERSION 9.5.0
+    VERSION 10.0.0
     DESCRIPTION "Python bindings for the Tango distributed control system"
     HOMEPAGE_URL "https://pytango.readthedocs.io/"
     LANGUAGES CXX
 )
 
 include(cmake/project-is-top-level.cmake)
-
-set(CMAKE_CXX_STANDARD 14)
 
 # ---- Dependencies -------
 
@@ -28,7 +26,7 @@
 # but gracefully try using cmake ways if pkg-config is not available (i.e. Windows)
 # or tango is not found.
 # Use the environment/cache variable Tango_ROOT to set the tango installation prefix.
-list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/cmake)
+list(APPEND CMAKE_MODULE_PATH ${CMAKE_CURRENT_SOURCE_DIR}/TangoCMakeModules)
 find_package(Tango REQUIRED)
 
 # Find Python and NumPy
@@ -118,7 +116,6 @@
     ext/device_info.cpp
     ext/periodic_event_info.cpp
     ext/database.cpp
-    ext/precompiled_header.cpp
     ext/enums.cpp
     ext/attribute_proxy.cpp
     ext/pyutils.cpp
@@ -140,8 +137,11 @@
     ext/group.cpp
     ext/event_data.cpp
     ext/data_ready_event_data.cpp
+    ext/tango_numpy.cpp
 )
 add_library(pytango::tango ALIAS pytango_tango)
+
+target_precompile_headers(pytango_tango PRIVATE ext/precompiled_header.hpp)
 
 set_target_properties(
     pytango_tango PROPERTIES
@@ -158,13 +158,13 @@
   # .so suffix is default on linux and required for python to load
     # the extension module. On MacOS the default is .dylib so we have
     # to force the suffix here.
-    set_target_properties(pytango_tango PROPERTIES SUFFIX ".so")  
+    set_target_properties(pytango_tango PROPERTIES SUFFIX ".so")
 endif()
 if (WIN32)
     set_target_properties(
         pytango_tango PROPERTIES
         SUFFIX ".pyd"
-        COMPILE_OPTIONS "/bigobj"
+        COMPILE_OPTIONS "/bigobj;-DPYTANGO_NUMPY_VERSION=${Python_NumPy_VERSION};-DNPY_NO_DEPRECATED_API=0"
     )
 endif()
 
@@ -174,13 +174,17 @@
     "$<BUILD_INTERFACE:${PROJECT_SOURCE_DIR}/ext>"
 )
 
-target_compile_features(pytango_tango PUBLIC cxx_std_14)
+target_compile_features(pytango_tango PUBLIC cxx_std_17)
 
 target_link_libraries(pytango_tango PRIVATE Python::Module Python::NumPy Boost::python Tango::Tango)
 
 install(TARGETS pytango_tango
 	LIBRARY DESTINATION tango
 	RUNTIME DESTINATION tango)
+
+if(NOT CMAKE_CROSSCOMPILING)
+  include(cmake/generate_stubs.cmake)
+endif()
 
 # ---- Developer mode ----
 
@@ -192,4 +196,3 @@
       "Developer mode is intended for developers of pytango"
   )
 endif()
-

=== examples/pipeEvents/Makefile ===
#=============================================================================
#
# file :        Makefile
#
# description : Makefile to generate a TANGO device server.
#
# project :     PipeServer
#
# $Author:  $
#
# $Revision:  $
# $Date:  $
#
#=============================================================================
#                This file is generated by POGO
#        (Program Obviously used to Generate tango Object)
#=============================================================================
#
#
#=============================================================================
# MAKE_ENV is the path to find common environment to buil project
#
MAKE_ENV = /usr/local/share/pogo/preferences

#=============================================================================
# PACKAGE_NAME is the name of the library/device/exe you want to build
#
PACKAGE_NAME = PipeServer
MAJOR_VERS   = 1
MINOR_VERS   = 0
RELEASE      = Release_$(MAJOR_VERS)_$(MINOR_VERS)

# #=============================================================================
# # RELEASE_TYPE
# # - DEBUG     : debug symbols - no optimization
# # - OPTIMIZED : no debug symbols - optimization level set to O2
# #-----------------------------------------------------------------------------
RELEASE_TYPE = DEBUG

#=============================================================================
# OUTPUT_TYPE can be one of the following :
#   - 'STATIC_LIB' for a static library (.a)
#   - 'SHARED_LIB' for a dynamic library (.so)
#   - 'DEVICE' for a device server (will automatically include and link
#            with Tango dependencies)
#   - 'SIMPLE_EXE' for an executable with no dependency (for exemple the test tool
#                of a library with no Tango dependencies)
#
OUTPUT_TYPE = DEVICE

#=============================================================================
# OUTPUT_DIR  is the directory which contains the build result.
# if not set, the standard location is :
#	- ./shlib if OUTPUT_TYPE is SHARED_LIB
#	- ./lib   if OUTPUT_TYPE is STATIC_LIB
#	- ./bin for others
#
#OUTPUT_DIR =


#=============================================================================
# INC_DIR_USER is the list of all include path needed by your sources
#   - for a device server, tango dependencies are automatically appended
#   - '-I ../include' and '-I .' are automatically appended in all cases
#
INC_DIR_USER= -I .

#=============================================================================
# LIB_DIR_USER is the list of user library directories
#   - for a device server, tango libraries directories are automatically appended
#   - '-L ../lib' is automatically appended in all cases
#
#LIB_DIR_USER=

#=============================================================================
# LFLAGS_USR is the list of user link flags
#   - for a device server, tango libraries directories are automatically appended
#   - '-ldl -lpthread' is automatically appended in all cases
#
# !!! ATTENTION !!!
# Be aware that the order matters.
# For example if you must link with libA, and if libA depends itself on libB
# you must use '-lA -lB' in this order as link flags, otherwise you will get
# 'undefined reference' errors
#
#LFLAGS_USR+=


#=============================================================================
# CXXFLAGS_USR lists the compilation flags specific for your library/device/exe
# This is the place where to put your compile-time macros using '-Dmy_macro'
#
# -DACE_HAS_EXCEPTIONS -D__ACE_INLINE__ for ACE
#
CXXFLAGS_USR+= -std=c++11


#=============================================================================
# TANGO_REQUIRED
# - TRUE  : your project depends on TANGO
# - FALSE : your project does not depend on TANGO
#-----------------------------------------------------------------------------
# - NOTE : if PROJECT_TYPE is set to DEVICE, TANGO will be auto. added
#-----------------------------------------------------------------------------
TANGO_REQUIRED = TRUE



#=============================================================================
#	include Standard TANGO compilation options
#
include $(MAKE_ENV)/tango.opt

#=============================================================================
#	POST_PROCESSING: action to be done after normal make.
#	e.g.:  change executable file name, .....
#POST_PROCESSING = \
#	mv bin/$(BIN_DIR)/$(PACKAGE_NAME) bin/$(BIN_DIR)/$(PACKAGE_NAME)_DS

#=============================================================================
# SVC_OBJS is the list of all objects needed to make the output
#
SVC_INCL =  $(PACKAGE_NAME).h $(PACKAGE_NAME)Class.h


SVC_OBJS =      \
		$(LIB_OBJS) \
		$(OBJDIR)/ClassFactory.o  \
        $(OBJDIR)/main.o

LIB_OBJS = \
        $(OBJDIR)/$(PACKAGE_NAME).o \
        $(OBJDIR)/$(PACKAGE_NAME)Class.o \
        $(OBJDIR)/$(PACKAGE_NAME)StateMachine.o \
        $(ADDITIONAL_OBJS)

SVC_INHERITANCE_OBJ =  \


#=============================================================================
#	include common targets
#
include $(MAKE_ENV)/common_target.opt

=== debian/changelog ===
pytango (10.0.0-4) unstable; urgency=medium

  * Team upload.
  * Disable some more tests that regularly fail

 -- Santiago Ruano Rincón <santiago@freexian.com>  Fri, 24 Jan 2025 18:08:09 -0300

pytango (10.0.0-3) unstable; urgency=medium

  * Team upload
  * Disable tests/test_event.py at build and autopkgtest time.
    Some test_event tests are flaky, and are blocking gcc-14 migration.
    (Closes: 1091861)
  * Wrap and sort -st, again, with devscripts 2.25.1
  * Replace obsolete Build-Dep pkg-config with pkgconf
  * Remove no longer needed copyright entry for tango/asyncio_tools.py

 -- Santiago Ruano Rincón <santiago@freexian.com>  Tue, 21 Jan 2025 09:48:34 -0500

pytango (10.0.0-2) unstable; urgency=medium

  * Team upload
  * Install python3-all-dev instead of python3-dev in d/tests/control.
    While there is more than one python version available (tpython3.12 and
    python3.13) the test cannot find the one that is not the default.
  * Add patch to fix assert_close for booleans with pytest >= 8.3.4

 -- Santiago Ruano Rincón <santiago@freexian.com>  Thu, 05 Dec 2024 17:25:13 -0300

pytango (10.0.0-1) unstable; urgency=medium

  * Team upload
  * Workaround FTBFS with python3.13 (Closes: #1087905)
  * Allow test suite to fail at build time

 -- Santiago Ruano Rincón <santiago@freexian.com>  Sat, 30 Nov 2024 09:44:14 -0300

pytango (10.0.0-1~exp1) experimental; urgency=medium

  * Team upload

  * New upstream version 10.0.0
  * Bump Build-dependencies to tango >= 10.0.0
  * Remove RELEASE variable from salsa-ci.yml definition
  * Drop no longer needed remove-junitxml-report.patch
  * Refresh patches
  * Add build-dependency on python3-pytest-asyncio
  * Enable wrap-and-sort job in Salsa CI
  * wrap-and-sort -st (debian/tests/control)
  * Add build-dependency on python-is-python3
  * Add build-dependency on opentelemetry-cpp-dev
  * Add patch to disable failing tests

 -- Santiago Ruano Rincón <santiago@freexian.com>  Sat, 09 Nov 2024 14:01:48 -0300

=== debian/control ===
--- 
+++ 
@@ -7,15 +7,17 @@
 Section: science
 Priority: optional
 Build-Depends:
- cmake,
- cppzmq-dev,
  debhelper-compat (= 13),
  dh-sequence-numpy3,
  dh-sequence-python3,
+ cmake,
+ cppzmq-dev,
  libboost-python-dev (>= 1.83.0),
- libtango-dev (>= 9.5.0+dfsg1),
- pkg-config,
+ libtango-dev (>= 10.0.0+dfsg1),
+ opentelemetry-cpp-dev,
+ pkgconf,
  pybuild-plugin-pyproject,
+ python-is-python3,
  python3-all-dev,
  python3-gevent,
  python3-numpy,
@@ -23,11 +25,12 @@
  python3-psutil <!nocheck>,
  python3-pyproject-metadata,
  python3-pytest <!nocheck>,
+ python3-pytest-asyncio <!nocheck>,
  python3-pytest-forked <!nocheck>,
  python3-pytest-rerunfailures <!nocheck>,
  python3-scikit-build-core,
  python3-setuptools,
- tango-test (>= 9.5.0+dfsg1) <!nocheck>,
+ tango-test (>= 10.0.0+dfsg1) <!nocheck>,
 Build-Depends-Indep:
  dh-sequence-sphinxdoc <!nodoc>,
  graphviz <!nodoc>,

=== debian/rules ===
--- 
+++ 
@@ -9,4 +9,12 @@
 	dh_auto_build --buildsystem=pybuild -- -s custom --build-args="PYTHONPATH={build_dir} {interpreter} -m sphinx -N -bhtml doc build/html"
 
 override_dh_auto_test:
-	PATH="/usr/lib/tango/:$$PATH" dh_auto_test --buildsystem=pybuild -- --test-pytest
+	# See: #1087905
+	#
+	# Also, some tests are failing sometimes. Allow them to fail for now,
+	# until there are more reliable tests.
+	-set -e; for py in $(shell py3versions -s) ; do \
+		export PYTHON=/usr/bin/$$py ; \
+		PATH="/usr/lib/tango/:$$PATH" dh_auto_test --buildsystem=pybuild -- \
+		--test-pytest ; \
+	done

=== debian/tests/control ===
# tests from tests/test_event.py regularly fail, so they are temporarily disabled
Test-Command: set -efu
 ; cp  -r tests "$AUTOPKGTEST_TMP"
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; PATH=/usr/lib/tango/:$PATH $py -m pytest tests -v --forked --ignore tests/test_event.py --reruns 5
 ; done
Depends:
 python3-all-dev,
 python3-psutil,
 python3-pytest,
 python3-pytest-forked,
 python3-pytest-rerunfailures,
 python3-tango,
 tango-test,
Restrictions: allow-stderr, isolation-container, skip-not-installable,

Test-Command: set -efu
 ; for py in $(py3versions -r 2>/dev/null)
 ; do cd "$AUTOPKGTEST_TMP"
 ; echo "Testing with $py:"
 ; $py -c "import tango; print(tango.Database().get_info())"
 ; done
Depends: default-mysql-server, python3-all-dev, python3-tango, tango-db,
Restrictions: allow-stderr, flaky, isolation-container, skip-not-installable,

## pytango 10.0.2

=== CMakeLists.txt ===
--- 
+++ 
@@ -7,7 +7,7 @@
 
 project(
     pytango
-    VERSION 10.0.0
+    VERSION 10.0.2
     DESCRIPTION "Python bindings for the Tango distributed control system"
     HOMEPAGE_URL "https://pytango.readthedocs.io/"
     LANGUAGES CXX
@@ -35,7 +35,7 @@
     set(Python_ROOT_DIR "$ENV{PYTHON_ROOT}" CACHE STRING "Python root installation path")
     set(Python_FIND_STRATEGY LOCATION)
 endif()
-find_package (Python 3.8 COMPONENTS Interpreter Development NumPy)
+find_package (Python 3.9 COMPONENTS Interpreter Development NumPy)
 message(STATUS "    Python version:  ${Python_VERSION}")
 message(STATUS "      - intepreter:  ${Python_EXECUTABLE}")
 message(STATUS "       - libraries:  ${Python_LIBRARIES}")
@@ -114,6 +114,7 @@
     ext/server/user_default_attr_prop.cpp
     ext/attr_conf_event_data.cpp
     ext/device_info.cpp
+    ext/coverage.cpp
     ext/periodic_event_info.cpp
     ext/database.cpp
     ext/enums.cpp
@@ -186,6 +187,17 @@
   include(cmake/generate_stubs.cmake)
 endif()
 
+option(PYTANGO_ENABLE_COVERAGE "Instrument code for coverage analysis" OFF)
+if(PYTANGO_ENABLE_COVERAGE AND NOT (CMAKE_CXX_COMPILER_ID MATCHES "GNU"))
+  message(FATAL_ERROR "Code coverage is not supported for selected compiler.")
+endif()
+
+if(PYTANGO_ENABLE_COVERAGE)
+  target_compile_definitions(pytango_tango PRIVATE PYTANGO_ENABLE_COVERAGE=1)
+  target_compile_options(pytango_tango PRIVATE --coverage -Wl,--dynamic-list-data)
+  target_link_options(pytango_tango PRIVATE --coverage -Wl,--dynamic-list-data)
+endif()
+
 # ---- Developer mode ----
 
 if(NOT pytango_DEVELOPER_MODE)

=== examples/interfacechangeEvents/Makefile ===
#=============================================================================
#
# file :        Makefile
#
# description : Makefile to generate a TANGO device server.
#
# project :     IfchangeServer
#
# $Author:  $
#
# $Revision:  $
# $Date:  $
#
#=============================================================================
#                This file is generated by POGO
#        (Program Obviously used to Generate tango Object)
#=============================================================================
#
#
#=============================================================================
# MAKE_ENV is the path to find common environment to buil project
#
MAKE_ENV = /usr/local/share/pogo/preferences

#=============================================================================
# PACKAGE_NAME is the name of the library/device/exe you want to build
#
PACKAGE_NAME = IfchangeServer
MAJOR_VERS   = 1
MINOR_VERS   = 0
RELEASE      = Release_$(MAJOR_VERS)_$(MINOR_VERS)

# #=============================================================================
# # RELEASE_TYPE
# # - DEBUG     : debug symbols - no optimization
# # - OPTIMIZED : no debug symbols - optimization level set to O2
# #-----------------------------------------------------------------------------
RELEASE_TYPE = DEBUG

#=============================================================================
# OUTPUT_TYPE can be one of the following :
#   - 'STATIC_LIB' for a static library (.a)
#   - 'SHARED_LIB' for a dynamic library (.so)
#   - 'DEVICE' for a device server (will automatically include and link
#            with Tango dependencies)
#   - 'SIMPLE_EXE' for an executable with no dependency (for exemple the test tool
#                of a library with no Tango dependencies)
#
OUTPUT_TYPE = DEVICE

#=============================================================================
# OUTPUT_DIR  is the directory which contains the build result.
# if not set, the standard location is :
#	- ./shlib if OUTPUT_TYPE is SHARED_LIB
#	- ./lib   if OUTPUT_TYPE is STATIC_LIB
#	- ./bin for others
#
#OUTPUT_DIR =


#=============================================================================
# INC_DIR_USER is the list of all include path needed by your sources
#   - for a device server, tango dependencies are automatically appended
#   - '-I ../include' and '-I .' are automatically appended in all cases
#
INC_DIR_USER= -I .

#=============================================================================
# LIB_DIR_USER is the list of user library directories
#   - for a device server, tango libraries directories are automatically appended
#   - '-L ../lib' is automatically appended in all cases
#
LIB_DIR_USER=

#=============================================================================
# LFLAGS_USR is the list of user link flags
#   - for a device server, tango libraries directories are automatically appended
#   - '-ldl -lpthread' is automatically appended in all cases
#
# !!! ATTENTION !!!
# Be aware that the order matters.
# For example if you must link with libA, and if libA depends itself on libB
# you must use '-lA -lB' in this order as link flags, otherwise you will get
# 'undefined reference' errors
#
#LFLAGS_USR+=


#=============================================================================
# CXXFLAGS_USR lists the compilation flags specific for your library/device/exe
# This is the place where to put your compile-time macros using '-Dmy_macro'
#
# -DACE_HAS_EXCEPTIONS -D__ACE_INLINE__ for ACE
#
#CXXFLAGS_USR+= -Wall


#=============================================================================
# TANGO_REQUIRED
# - TRUE  : your project depends on TANGO
# - FALSE : your project does not depend on TANGO
#-----------------------------------------------------------------------------
# - NOTE : if PROJECT_TYPE is set to DEVICE, TANGO will be auto. added
#-----------------------------------------------------------------------------
TANGO_REQUIRED = TRUE



#=============================================================================
#	include Standard TANGO compilation options
#
include $(MAKE_ENV)/tango.opt

#=============================================================================
#	POST_PROCESSING: action to be done after normal make.
#	e.g.:  change executable file name, .....
#POST_PROCESSING = \
#	mv bin/$(BIN_DIR)/$(PACKAGE_NAME) bin/$(BIN_DIR)/$(PACKAGE_NAME)_DS

#=============================================================================
# SVC_OBJS is the list of all objects needed to make the output
#
SVC_INCL =  $(PACKAGE_NAME).h $(PACKAGE_NAME)Class.h


SVC_OBJS =      \
		$(LIB_OBJS) \
		$(OBJDIR)/ClassFactory.o  \
        $(OBJDIR)/main.o

LIB_OBJS = \
        $(OBJDIR)/$(PACKAGE_NAME).o \
        $(OBJDIR)/$(PACKAGE_NAME)Class.o \
        $(OBJDIR)/$(PACKAGE_NAME)StateMachine.o \
		$(OBJDIR)/$(PACKAGE_NAME)DynAttrUtils.o \
        $(ADDITIONAL_OBJS)

SVC_INHERITANCE_OBJ =  \


#=============================================================================
#	include common targets
#
include $(MAKE_ENV)/common_target.opt

=== debian/changelog ===
pytango (10.0.2-3) unstable; urgency=medium

  * Team upload.
  * Fix FTBFS with NumPy 2.3 (Closes: #1114714)

 -- Timo Röhling <roehling@debian.org>  Thu, 02 Oct 2025 17:00:03 +0200

pytango (10.0.2-2) unstable; urgency=medium

  * Team upload.
  * Unblock pytest 8.4 transition: autopkgtest need python3-pytest-asyncio
  * Drop "Rules-Requires-Root: no"
  * Apply Multi-Arch: hint

 -- Alexandre Detiste <tchet@debian.org>  Sat, 30 Aug 2025 11:49:45 +0200

pytango (10.0.2-1) unstable; urgency=medium

  * Team upload.
  * New upstream version 10.0.2
  * Add new doc-related build-dependencies.
    Because of changes introduced between 10.0.0 and 10.0.2.
  * Include libjs-d3 as {build-,}dependency
  * Include patch to avoid d3-related privacy breach
  * Link locally to d3.min.js before installing docs
  * Remove no longer needed 0001-Use-jquery-from-the-archive.patch
  * Remove no longer needed doc/_static/jssor* entry in d/copyright
  * Temporarily disable sphinx_book_theme.
    Until #1085947 gets fixed in unstable.
  * Refresh d/patches
  * Set localhost http(s)_proxy in override_dh_auto_build,
    to prevent sphinx accessing internet at build time.
  * Wrap and sort -ast and update salsa-ci wrap-and-sort job to always wrap
  * Add Freexian Packaging Team as Uploader
  * Update disabled tests
  * Include patch to add missing fortify source CPPFLAG
  * Add hardening flags to DEB_BUILD_MAINT_OPTIONS. bindnow hardening was
    missing.
  * Declare compliance with Standards-Version 4.7.2.
    No changes needed.

 -- Santiago Ruano Rincón <santiago@freexian.com>  Fri, 14 Mar 2025 13:44:13 -0300

=== debian/control ===
--- 
+++ 
@@ -4,6 +4,7 @@
  Picca Frédéric-Emmanuel <picca@debian.org>,
  Sandor Bodo-Merle <sbodomerle@gmail.com>,
  Roland Mas <lolando@debian.org>,
+ Freexian Packaging Team <team+freexian@tracker.debian.org>,
 Section: science
 Priority: optional
 Build-Depends:
@@ -13,6 +14,7 @@
  cmake,
  cppzmq-dev,
  libboost-python-dev (>= 1.83.0),
+ libjs-d3,
  libtango-dev (>= 10.0.0+dfsg1),
  opentelemetry-cpp-dev,
  pkgconf,
@@ -20,6 +22,7 @@
  python-is-python3,
  python3-all-dev,
  python3-gevent,
+ python3-myst-parser,
  python3-numpy,
  python3-pathspec,
  python3-psutil <!nocheck>,
@@ -30,6 +33,11 @@
  python3-pytest-rerunfailures <!nocheck>,
  python3-scikit-build-core,
  python3-setuptools,
+ python3-sphinx-book-theme,
+ python3-sphinx-copybutton,
+ python3-sphinx-design,
+ python3-sphinx-togglebutton,
+ python3-sphinxcontrib-mermaid,
  tango-test (>= 10.0.0+dfsg1) <!nocheck>,
 Build-Depends-Indep:
  dh-sequence-sphinxdoc <!nodoc>,
@@ -37,18 +45,21 @@
  python3-sphinx <!nodoc>,
  python3-sphinx-rtd-theme <!nodoc>,
  sphinx-common <!nodoc>,
-Standards-Version: 4.6.1
+Standards-Version: 4.7.2
 Vcs-Browser: https://salsa.debian.org/science-team/pytango
 Vcs-Git: https://salsa.debian.org/science-team/pytango.git
 Homepage: https://pytango.readthedocs.io/en/latest/
-Rules-Requires-Root: no
 
 Package: python3-tango
 # Architecture: any [!390x]
 Architecture: alpha amd64 arm64 armel armhf hppa hurd-amd64 hurd-i386 i386 ia64 loong64 m68k mips64el powerpc ppc64 ppc64el riscv64 sh4 sparc64 x32
 Section: python
-Depends: ${misc:Depends}, ${python3:Depends}, ${shlibs:Depends},
-Provides: ${python3:Provides},
+Depends:
+ ${misc:Depends},
+ ${python3:Depends},
+ ${shlibs:Depends},
+Provides:
+ ${python3:Provides},
 Description: API for the TANGO control system (Python 3)
  TANGO is an object oriented distributed control system using CORBA,
  mainly developed by the Controls Section of the ALBA Synchrotron.
@@ -60,10 +71,16 @@
 
 Package: python-tango-doc
 Architecture: all
+Multi-Arch: foreign
 Section: doc
-Depends: ${misc:Depends}, ${sphinxdoc:Depends},
-Breaks: python-pytango-doc (<< 9.2.0-2~),
-Replaces: python-pytango-doc (<< 9.2.0-2~),
+Depends:
+ libjs-d3,
+ ${misc:Depends},
+ ${sphinxdoc:Depends},
+Breaks:
+ python-pytango-doc (<< 9.2.0-2~),
+Replaces:
+ python-pytango-doc (<< 9.2.0-2~),
 Description: API for the TANGO control system
  TANGO is an object oriented distributed control system using CORBA,
  mainly developed by the Controls Section of the ALBA Synchrotron.

=== debian/rules ===
--- 
+++ 
@@ -2,11 +2,20 @@
 
 export PYBUILD_NAME=tango
 export PYBUILD_TEST_ARGS=--reruns 5
+export DEB_BUILD_MAINT_OPTIONS=hardening=+all
+
 %:
 	dh $@ --buildsystem=pybuild
 
+execute_after_dh_auto_build-indep: export http_proxy=127.0.0.1:9
+execute_after_dh_auto_build-indep: export https_proxy=127.0.0.1:9
 execute_after_dh_auto_build-indep:
 	dh_auto_build --buildsystem=pybuild -- -s custom --build-args="PYTHONPATH={build_dir} {interpreter} -m sphinx -N -bhtml doc build/html"
+
+execute_before_dh_installdocs:
+	mkdir -p $(CURDIR)/debian/python-tango-doc/usr/share/doc/python-tango-doc/html/usr/share/javascript/d3/
+	ln -s /usr/share/javascript/d3/d3.min.js	\
+		$(CURDIR)/debian/python-tango-doc/usr/share/doc/python-tango-doc/html/usr/share/javascript/d3/
 
 override_dh_auto_test:
 	# See: #1087905

=== debian/tests/control ===
--- 
+++ 
@@ -10,11 +10,15 @@
  python3-all-dev,
  python3-psutil,
  python3-pytest,
+ python3-pytest-asyncio,
  python3-pytest-forked,
  python3-pytest-rerunfailures,
  python3-tango,
  tango-test,
-Restrictions: allow-stderr, isolation-container, skip-not-installable,
+Restrictions:
+ allow-stderr,
+ isolation-container,
+ skip-not-installable,
 
 Test-Command: set -efu
  ; for py in $(py3versions -r 2>/dev/null)
@@ -22,5 +26,13 @@
  ; echo "Testing with $py:"
  ; $py -c "import tango; print(tango.Database().get_info())"
  ; done
-Depends: default-mysql-server, python3-all-dev, python3-tango, tango-db,
-Restrictions: allow-stderr, flaky, isolation-container, skip-not-installable,
+Depends:
+ default-mysql-server,
+ python3-all-dev,
+ python3-tango,
+ tango-db,
+Restrictions:
+ allow-stderr,
+ flaky,
+ isolation-container,
+ skip-not-installable,

=== debian/watch ===
version=4
opts=uversionmangle=s/(rc|a|b|c)/~$1/ \
https://pypi.debian.net/pytango/pytango-(.+)\.(?:zip|tgz|tbz|txz|(?:tar\.(?:gz|bz2|xz)))
